VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GetIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Type ICONDIRENTRY
   bWidth        As Byte      '// Width of the image
   bHeight       As Byte        '// Height of the image (times 2)
   bColorCount   As Byte          '// Number of colors in image (0 if >=8bpp)
   bReserved     As Byte            '// Reserved
   wPlanes       As Integer           '// Color Planes
   wBitCount     As Integer             '// Bits per pixel
   dwBytesInRes  As Long               '// how many bytes in this resource?
   dwImageOffset As Long              '// where in the file is this image
End Type
Private Type ICONDIR
   idReserved    As Integer   '// Reserved
   idType        As Integer     '// resource type (1 for icons)
   idCount       As Integer       '// how many images?
End Type
Private Type MEMICONDIRENTRY
   bWidth        As Byte        '// Width of the image
   bHeight       As Byte        '// Height of the image (times 2)
   bColorCount   As Byte        '// Number of colors in image (0 if >=8bpp)
   bReserved     As Byte        '// Reserved
   wPlanes       As Integer     '// Color Planes
   wBitCount     As Integer     '// Bits per pixel
   dwBytesInRes  As Long        '// how many bytes in this resource?
   nID           As Integer     '// the ID
End Type
Private Type tBits
    bBits()      As Byte
End Type
Private Type ICONINFO
   fIcon         As Long
   xHotspot      As Long
   yHotspot      As Long
   hBmMask       As Long
   hbmColor      As Long
End Type
Private Type PictDesc
    cbSizeofStruct As Long
    picType        As Long
    hImage         As Long
    xExt           As Long
    yExt           As Long
End Type
Private Type Guid
    Data1          As Long
    Data2          As Integer
    Data3          As Integer
    Data4(0 To 7)  As Byte
End Type
Private Type BITMAPINFOHEADER ' 40 Bytes
   biSize          As Long
   biWidth         As Long
   biHeight        As Long
   biPlanes        As Integer
   biBitCount      As Integer
   biCompression   As Long
   biSizeImage     As Long
   biXPelsPerMeter As Long
   biYPelsPerMeter As Long
   biClrUsed       As Long
   biClrImportant  As Long
End Type
Private Type RGBQUAD
   RGBBlue         As Byte
   RGBGreen        As Byte
   RGBRed          As Byte
   rgbReserved     As Byte
End Type
Private Type BITMAPINFO_1BPP
   bmiHeader       As BITMAPINFOHEADER
   bmiColors(1)    As RGBQUAD
End Type

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
                    ByVal lpFileName As String, _
                    ByVal dwDesiredAccess As Long, _
                    ByVal dwShareMode As Long, _
                    lpSecurityAttributes As Any, _
                    ByVal dwCreationDisposition As Long, _
                    ByVal dwFlagsAndAttributes As Long, _
                    ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function ReadFile Lib "kernel32" ( _
                    ByVal hFile As Long, _
                    lpBuffer As Any, _
                    ByVal nNumberOfBytesToRead As Long, _
                    lpNumberOfBytesRead As Long, _
                    lpOverlapped As Any) As Long
Private Declare Function WriteFile Lib "kernel32" ( _
                    ByVal hFile As Long, _
                    lpBuffer As Any, _
                    ByVal nNumberOfBytesToWrite As Long, _
                    lpNumberOfBytesWritten As Long, _
                    lpOverlapped As Any) As Long
Private Declare Function SetFilePointer Lib "kernel32" ( _
                    ByVal hFile As Long, _
                    ByVal lDistanceToMove As Long, _
                    lpDistanceToMoveHigh As Long, _
                    ByVal dwMoveMethod As Long) As Long
Private Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" ( _
                    ByVal lpLibFileName As String, _
                    ByVal hFile As Long, _
                    ByVal dwFlags As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function LoadResource Lib "kernel32" ( _
                    ByVal hInstance As Long, _
                    ByVal hResInfo As Long) As Long
Private Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
Private Declare Function FindResource Lib "kernel32" Alias "FindResourceA" ( _
                    ByVal hInstance As Long, _
                    lpName As Any, _
                    lpType As Any) As Long
Private Declare Function SizeofResource Lib "kernel32" ( _
                    ByVal hInstance As Long, _
                    ByVal hResInfo As Long) As Long
Private Declare Function SetDIBitsToDevice Lib "gdi32" ( _
                    ByVal Hdc As Long, _
                    ByVal X As Long, ByVal Y As Long, _
                    ByVal dx As Long, ByVal dy As Long, _
                    ByVal SrcX As Long, ByVal SrcY As Long, _
                    ByVal Scan As Long, _
                    ByVal NumScans As Long, _
                    Bits As Any, _
                    BitsInfo As Any, _
                    ByVal wUsage As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal Hdc As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal Hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" ( _
                    ByVal Hdc As Long, _
                    ByVal nWidth As Long, _
                    ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" ( _
                    ByVal Hdc As Long, _
                    ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" ( _
                    ByVal Hdc As Long, _
                    ByVal X As Long, ByVal Y As Long, _
                    ByVal nWidth As Long, ByVal nHeight As Long, _
                    ByVal hSrcDC As Long, _
                    ByVal xSrc As Long, _
                    ByVal ySrc As Long, _
                    ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, _
                    ByVal dwRop As Long) As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" ( _
                    lpPictDesc As PictDesc, _
                    riid As Guid, _
                    ByVal fPictureOwnsHandle As Long, _
                    ipic As IPicture) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
                    lpvDest As Any, _
                    lpvSource As Any, _
                    ByVal cbCopy As Long)
Private Declare Function CreateIconIndirect Lib "User32" (piconinfo As ICONINFO) As Long

Public Enum ECFIImageConstants
    ecfiImage = 0
    ecfiMask = 1
End Enum

Private Const FILE_BEGIN = 0
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING = 3
Private Const CREATE_ALWAYS = 2
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const INVALID_HANDLE_VALUE = -1
Private Const LOAD_LIBRARY_AS_DATAFILE = &H2&
Private Const RT_ICON = 3
Private Const DIFFERENCE = 11
Private Const RT_GROUP_ICON = RT_ICON + DIFFERENCE
Private Const IMAGE_ICON = 1
Private Const DIB_RGB_COLORS = 0 '  color table in RGBs
Private Const BI_RGB = 0&
Private Const Dll_unSuccessful = 0

Private m_sFile   As String
Private m_vID     As Variant
Private m_tID     As ICONDIR
Private m_tIDE()  As ICONDIRENTRY
Private m_tBits() As tBits
Public Property Get FileName() As String: FileName = m_sFile:    End Property
Public Property Get ResourceID() As Variant: ResourceID = m_vID: End Property
Public Property Get IconPicture(ByVal lHDC As Long, ByVal nIndex As Long) As StdPicture
Dim hIcon As Long
     hIcon = IconHandle(lHDC, nIndex)

   If (hIcon <> 0) Then Set IconPicture = IconToPicture(hIcon)
   
End Property
Public Property Get IconHandle(ByVal lHDC As Long, ByVal nIndex As Long) As Long
Dim hBmpAND As Long
Dim hBmpXOR As Long
Dim tII     As ICONINFO
   
    tII.fIcon = IMAGE_ICON
    tII.hbmColor = GetIconBitmap(lHDC, nIndex, ecfiImage, False, bReturnBmp:=True)
    tII.hBmMask = GetIconBitmap(lHDC, nIndex, ecfiMask, False, bReturnBmp:=True)
    IconHandle = CreateIconIndirect(tII)
    
    Call DeleteObject(tII.hbmColor)
    Call DeleteObject(tII.hBmMask)

End Property
Public Property Get ImageCount() As Long: ImageCount = m_tID.idCount: End Property
Public Property Get ImageWidth(ByVal nIndex As Long) As Long

    ImageWidth = m_tIDE(nIndex - 1).bWidth

End Property
Public Property Get ImageHeight(ByVal nIndex As Long) As Long

    ImageHeight = m_tIDE(nIndex - 1).bHeight

End Property
Public Property Get ImageColourCount(ByVal nIndex As Long) As Double

    If (m_tIDE(nIndex - 1).bColorCount = 0) Then
        ImageColourCount = 2 ^ m_tIDE(nIndex - 1).wBitCount
    Else
        ImageColourCount = m_tIDE(nIndex - 1).bColorCount
    End If

End Property
Public Property Get ImageSize(ByVal nIndex As Long) As Long

    ImageSize = m_tIDE(nIndex - 1).dwBytesInRes

End Property
Public Property Get LargeIndex() As Long
Dim LargeWidth As Long
Dim LargeColor As Double, ColourCount As Double
    
    For ISum = 1 To m_tID.idCount
        If LargeWidth <= m_tIDE(ISum - 1).bWidth Then
            LargeWidth = m_tIDE(ISum - 1).bWidth
            ColourCount = Me.ImageColourCount(ISum)
            If LargeColor < ColourCount Then
                LargeColor = ColourCount
                LargeIndex = ISum
            End If
        End If
    Next ISum

End Property
Public Property Get SmallIndex() As Long
Dim SmallWidth As Long
Dim LargeColor As Double, ColourCount As Double
    
    SmallIndex = 1
    SmallWidth = m_tIDE(0).bWidth
    LargeColor = Me.ImageColourCount(1)
    For ISum = 2 To m_tID.idCount
        If SmallWidth >= m_tIDE(ISum - 1).bWidth Then
            SmallWidth = m_tIDE(ISum - 1).bWidth
            ColourCount = Me.ImageColourCount(ISum)
            If LargeColor <= ColourCount Then
                LargeColor = ColourCount
                SmallIndex = ISum
            End If
        End If
    Next ISum

End Property
Public Property Get IndexWidth(WidthIn As Integer) As Long
Dim LargeColor As Double, ColourCount As Double
    
    IndexWidth = 1
    'LargeColor = 0
    For ISum = 2 To m_tID.idCount
        If m_tIDE(ISum - 1).bWidth = WidthIn Then
            ColourCount = Me.ImageColourCount(ISum)
            If LargeColor <= ColourCount Then
                LargeColor = ColourCount
                IndexWidth = ISum
            End If
        End If
    Next ISum

End Property
Private Function IconToPicture(ByVal hIcon As Long) As IPicture
         If hIcon = 0 Then Exit Function
Dim NewPic  As Picture, _
    PicConv As PictDesc, _
    IGuid   As Guid
    
    PicConv.cbSizeofStruct = Len(PicConv)
    PicConv.picType = vbPicTypeIcon
    PicConv.hImage = hIcon
    
    With IGuid
        .Data1 = &H7BF80980
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    Call OleCreatePictureIndirect(PicConv, IGuid, True, NewPic)
    
    Set IconToPicture = NewPic
    
End Function
Public Function LoadIconFromEXE(ByVal sFile As String, _
                                Optional ByVal lpID As Long = 0, _
                                Optional ByVal lpName As String = Empty _
                                ) As Boolean
Dim hLibrary    As Long
Dim hRsrc       As Long
Dim hGlobal     As Long
Dim lPtr        As Long
Dim iEntry      As Long
Dim tMIDE       As MEMICONDIRENTRY
Dim nID()       As Integer
Dim iBaseOffset As Long
Dim lSize       As Long
Dim bFail       As Boolean

    m_sFile = sFile
    m_vID = Empty
    Erase m_tIDE
    Erase m_tBits
    
    With m_tID
       .idCount = 0
       .idReserved = 0
       .idType = 0
    End With
   

    hLibrary = LoadLibraryEx(sFile, ByVal 0&, LOAD_LIBRARY_AS_DATAFILE)
    If (hLibrary = Dll_unSuccessful) Then GoTo ErrorTrap
      
    If (lpID <> 0) Then
        lpName = "#" & CStr(lpID)
        hRsrc = FindResource(hLibrary, ByVal lpName, ByVal RT_GROUP_ICON)
        m_vID = lpID
    Else
        hRsrc = FindResource(hLibrary, ByVal lpName, ByVal RT_GROUP_ICON)
        m_vID = lpName
    End If
    If (hRsrc = Dll_unSuccessful) Then GoTo ErrorTrap
    
    hGlobal = LoadResource(hLibrary, hRsrc)
    If (hGlobal = Dll_unSuccessful) Then GoTo ErrorTrap

    lPtr = LockResource(hGlobal)
    If (lPtr = Dll_unSuccessful) Then GoTo ErrorTrap
    
    Call CopyMemory(m_tID, ByVal lPtr, Len(m_tID))
             
    If (m_tID.idCount > 0) Then
        ReDim m_tIDE(0 To m_tID.idCount - 1) As ICONDIRENTRY
        ReDim nID(0 To m_tID.idCount - 1) As Integer
        ReDim b(0 To Len(m_tID) + Len(tMIDE) * m_tID.idCount - 1) As Byte
        Call CopyMemory(b(0), ByVal lPtr, Len(m_tID) + Len(tMIDE) * m_tID.idCount)
                
        For iEntry = 0 To m_tID.idCount - 1
            Call CopyMemory(tMIDE, b(Len(m_tID) + iEntry * Len(tMIDE)), Len(tMIDE))
            nID(iEntry) = tMIDE.nID
            CopyMemory m_tIDE(iEntry), tMIDE, Len(tMIDE)
        Next iEntry
                
        iBaseOffset = Len(m_tID) + Len(m_tIDE(0)) * m_tID.idCount
        m_tIDE(0).dwImageOffset = iBaseOffset
        For iEntry = 1 To m_tID.idCount - 1
            m_tIDE(iEntry).dwImageOffset = m_tIDE(iEntry - 1).dwImageOffset + m_tIDE(iEntry - 1).dwBytesInRes
        Next iEntry
                
        ReDim m_tBits(0 To m_tID.idCount - 1) As tBits
        bFail = True
        For iEntry = 0 To m_tID.idCount - 1
            lpName = "#" & nID(iEntry)
            hRsrc = FindResource(hLibrary, ByVal lpName, ByVal RT_ICON)
            If (hRsrc = Dll_unSuccessful) Then GoTo FailP
            
            hGlobal = LoadResource(hLibrary, hRsrc)
            If (hGlobal = Dll_unSuccessful) Then GoTo FailP
            
            lSize = SizeofResource(hLibrary, hRsrc)
            If (lSize > 0) And (lSize = m_tIDE(iEntry).dwBytesInRes) Then
                lPtr = LockResource(hGlobal)
                If (lPtr = Dll_unSuccessful) Then GoTo FailP
                ReDim Preserve m_tBits(iEntry).bBits(0 To lSize - 1) As Byte
                CopyMemory m_tBits(iEntry).bBits(0), ByVal lPtr, lSize
            Else
                GoTo FailP
            End If
        Next iEntry
        bFail = False
FailP:
        If (bFail) Then
            sFile = Empty
            Erase m_tIDE
            Erase m_tBits
            m_tID.idCount = 0
            m_vID = Empty
            GoTo ErrorTrap
        End If
        
        LoadIconFromEXE = Not (bFail)
    End If
    
    Call FreeLibrary(hLibrary)
ErrorTrap:
End Function
Public Function LoadIcon(ByVal sFile As String) As Boolean
Dim hFile       As Long
Dim iValue      As Long
Dim iType       As Long
Dim iEntry      As Long
Dim i           As Long
Dim dwBytesRead As Long
Dim bFail       As Boolean
Dim sFail       As String
Dim tBMI        As BITMAPINFOHEADER

    m_sFile = sFile
    m_vID = Empty
    Erase m_tIDE
    Erase m_tBits
    
    With m_tID
       .idCount = 0
       .idReserved = 0
       .idType = 0
    End With

    hFile = CreateFile(sFile, GENERIC_READ, 0, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    If (hFile <> 0) Then
        Call ReadFile(hFile, m_tID, Len(m_tID), dwBytesRead, ByVal 0&)
        If (m_tID.idReserved = 0) Then
            If (m_tID.idType = IMAGE_ICON) Then
                If (m_tID.idCount > 0) Then
                    
                    ReDim m_tIDE(0 To m_tID.idCount - 1) As ICONDIRENTRY
                    For iEntry = 1 To m_tID.idCount
                        Call ReadFile(hFile, m_tIDE(iEntry - 1), Len(m_tIDE(iEntry - 1)), dwBytesRead, ByVal 0&)
                        If (dwBytesRead <> Len(m_tIDE(iEntry - 1))) Then
                            bFail = True
                            Exit For
                        End If
                    Next iEntry
                               
                    If Not (bFail) Then
                        ReDim m_tBits(0 To m_tID.idCount - 1) As tBits
                        For iEntry = 1 To m_tID.idCount
                            Call SetFilePointer(hFile, m_tIDE(iEntry - 1).dwImageOffset, ByVal 0&, FILE_BEGIN)
                            ReDim m_tBits(iEntry - 1).bBits(0 To m_tIDE(iEntry - 1).dwBytesInRes) As Byte
                            Call ReadFile(hFile, m_tBits(iEntry - 1).bBits(0), m_tIDE(iEntry - 1).dwBytesInRes, dwBytesRead, ByVal 0&)
                            If (dwBytesRead <> m_tIDE(iEntry - 1).dwBytesInRes) Then
                                bFail = True
                                Exit For
                            End If
                        Next iEntry
                        LoadIcon = Not (bFail)
                    End If

                End If
            End If
        End If
    End If
            
    Call CloseHandle(hFile)
      
    If (bFail) Then
         sFile = Empty
         Erase m_tIDE
         Erase m_tBits
         m_tID.idCount = 0
    End If

End Function
Public Function SaveIcon(Optional ByVal sFileName As String = Empty) As Boolean
Dim hFile          As Long
Dim dwBytesWritten As Long
Dim iEntry         As Long
Dim bFail          As Boolean
   
    If (m_sFile = Empty) Then _
        If (sFileName = Empty) Then GoTo ErrorTrap
    If (m_tID.idCount = 0) Then GoTo ErrorTrap
    If (sFileName <> Empty) Then m_sFile = sFileName
    hFile = CreateFile(m_sFile, GENERIC_WRITE, 0, ByVal 0&, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, ByVal 0&)
    If (hFile = INVALID_HANDLE_VALUE) Then GoTo ErrorTrap

    Call WriteFile(hFile, m_tID, Len(m_tID), dwBytesWritten, ByVal 0&)
    If (dwBytesWritten = Len(m_tID)) Then
        For iEntry = 0 To m_tID.idCount - 1
            Call WriteFile(hFile, m_tIDE(iEntry), Len(m_tIDE(iEntry)), dwBytesWritten, ByVal 0&)
            If (dwBytesWritten <> Len(m_tIDE(iEntry))) Then
                bFail = True
                Exit For
            End If
        Next iEntry

        If Not (bFail) Then
            For iEntry = 0 To m_tID.idCount - 1
                Call WriteFile(hFile, m_tBits(iEntry).bBits(0), m_tIDE(iEntry).dwBytesInRes, dwBytesWritten, ByVal 0&)
                If (m_tIDE(iEntry).dwBytesInRes <> dwBytesWritten) Then
                    bFail = True
                    Exit For
                End If
            Next iEntry
        End If
    Else
        bFail = True
    End If
    
    Call CloseHandle(hFile)
    If (bFail) Then GoTo ErrorTrap
    SaveIcon = Not (bFail)

End Function
Public Sub DrawIconImage(ByVal lHDC As Long, _
                         ByVal nIndex As Long, _
                         Optional ByVal eType As ECFIImageConstants = ecfiImage, _
                         Optional ByVal X As Long = 0, _
                         Optional ByVal Y As Long = 0, _
                         Optional ByVal lWidth As Long = 0, _
                         Optional ByVal lHeight As Long = 0, _
                         Optional ByVal eRasterOp As RasterOpConstants = vbSrcCopy)
         
   Call GetIconBitmap(lHDC, nIndex, eType, True, X, Y, lWidth, lHeight, eRasterOp)
   
End Sub
Private Function GetIconBitmap(ByVal lHDC As Long, _
                               ByVal nIndex As Long, _
                               ByVal eType As ECFIImageConstants, _
                               Optional ByVal bDrawToDC As Boolean = True, _
                               Optional ByVal X As Long, _
                               Optional ByVal Y As Long, _
                               Optional ByVal lWidth As Long, _
                               Optional ByVal lHeight As Long, _
                               Optional ByVal eOp As RasterOpConstants, _
                               Optional ByVal bReturnBmp As Boolean = False) As Long
Dim Hdc      As Long
Dim lR       As Long
Dim lAnd     As Long, lXor As Long
Dim tBMIH    As BITMAPINFOHEADER
Dim tBMIMono As BITMAPINFO_1BPP
Dim hBmp     As Long
Dim hBmpOld  As Long
      
    If (eType = ecfiImage) Then
        Hdc = CreateCompatibleDC(lHDC)
        If (Hdc <> 0) Then
            hBmp = CreateCompatibleBitmap(lHDC, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight)
            If (hBmp <> 0) Then
                hBmpOld = SelectObject(Hdc, hBmp)
                If (hBmpOld <> 0) Then
                    Call CopyMemory(tBMIH, m_tBits(nIndex - 1).bBits(0), Len(tBMIH))
                    tBMIH.biHeight = tBMIH.biHeight \ 2
                    Call CopyMemory(m_tBits(nIndex - 1).bBits(0), tBMIH, Len(tBMIH))
                
                    lXor = FindDIBits(tBMIH)
                    lR = SetDIBitsToDevice(Hdc, 0, 0, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, 0, 0, 0, m_tIDE(nIndex - 1).bHeight, m_tBits(nIndex - 1).bBits(lXor), m_tBits(nIndex - 1).bBits(0), DIB_RGB_COLORS)
                
                    If (bDrawToDC) Then
                        If (lWidth = 0) And (lHeight = 0) Then
                            Call BitBlt(lHDC, X, Y, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, Hdc, 0, 0, eOp)
                        Else
                            If (lWidth = 0) Then lWidth = m_tIDE(nIndex - 1).bWidth
                            If (lHeight = 0) Then lHeight = m_tIDE(nIndex - 1).bHeight
                            Call StretchBlt(lHDC, X, Y, lWidth, lHeight, Hdc, 0, 0, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, eOp)
                        End If
                    End If
               
                    Call CopyMemory(tBMIH, m_tBits(nIndex - 1).bBits(0), Len(tBMIH))
                    tBMIH.biHeight = tBMIH.biHeight * 2
                    Call CopyMemory(m_tBits(nIndex - 1).bBits(0), tBMIH, Len(tBMIH))
                  
                    Call SelectObject(Hdc, hBmpOld)
                End If
            
                If (bReturnBmp) Then GetIconBitmap = hBmp Else Call DeleteObject(hBmp)
            End If
            Call DeleteDC(Hdc)
        End If

    Else
        Hdc = CreateCompatibleDC(0&)
        If (Hdc <> 0) Then
            hBmp = CreateCompatibleBitmap(Hdc, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight)
            If (hBmp <> 0) Then
                hBmpOld = SelectObject(Hdc, hBmp)
                If (hBmpOld <> 0) Then
                    Call CopyMemory(tBMIMono.bmiHeader, m_tBits(nIndex - 1).bBits(0), Len(tBMIH))
                    lXor = FindDIBits(tBMIMono.bmiHeader)
                    lAnd = lXor + m_tIDE(nIndex - 1).bHeight * 1# * WidthBytes(tBMIMono.bmiHeader.biWidth * tBMIMono.bmiHeader.biPlanes * tBMIMono.bmiHeader.biBitCount)
               
                    With tBMIMono
                        With .bmiHeader
                            .biHeight = .biHeight \ 2
                            .biPlanes = 1
                            .biBitCount = 1
                            .biCompression = BI_RGB
                            .biSizeImage = 0
                            .biXPelsPerMeter = 0
                            .biYPelsPerMeter = 0
                            .biClrUsed = 0
                            .biClrImportant = 0
                        End With
                        With .bmiColors(0)
                            .RGBRed = 0
                            .RGBGreen = 0
                            .RGBBlue = 0
                            .rgbReserved = 0
                        End With
                        With .bmiColors(1)
                            .RGBRed = 255
                            .RGBGreen = 255
                            .RGBBlue = 255
                            .rgbReserved = 0
                        End With
                    End With
               
                    lR = SetDIBitsToDevice(Hdc, 0, 0, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, 0, 0, 0, m_tIDE(nIndex - 1).bHeight, m_tBits(nIndex - 1).bBits(lAnd), tBMIMono, DIB_RGB_COLORS)
               
                    If (bDrawToDC) Then
                        If (lWidth = 0) And (lHeight = 0) Then
                            Call BitBlt(lHDC, X, Y, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, Hdc, 0, 0, eOp)
                        Else
                            If (lWidth = 0) Then lWidth = m_tIDE(nIndex - 1).bWidth
                            If (lHeight = 0) Then lHeight = m_tIDE(nIndex - 1).bHeight
                            StretchBlt lHDC, X, Y, lWidth, lHeight, Hdc, 0, 0, m_tIDE(nIndex - 1).bWidth, m_tIDE(nIndex - 1).bHeight, eOp
                        End If
                    End If
                                 
                    Call SelectObject(Hdc, hBmpOld)
                End If
                If (bReturnBmp) Then GetIconBitmap = hBmp Else Call DeleteObject(hBmp)
            End If
         
            Call DeleteObject(Hdc)
        End If
    End If
   
End Function
Private Function FindDIBits(ByRef tBMI As BITMAPINFOHEADER) As Long
Dim tRGBQ As RGBQUAD
   
    FindDIBits = Len(tBMI) + DIBNumColors(tBMI) * Len(tRGBQ)

End Function
Private Function DIBNumColors(ByRef tBMI As BITMAPINFOHEADER) As Long
Dim wBitCount As Long
Dim dwClrUsed As Long

    dwClrUsed = tBMI.biClrUsed
    If (dwClrUsed <> 0) Then
        DIBNumColors = dwClrUsed
    Else
        wBitCount = tBMI.biBitCount
        Select Case wBitCount
            Case 1
                DIBNumColors = 2
            Case 4
                DIBNumColors = 16
            Case 8
                DIBNumColors = 256
            Case Else
                DIBNumColors = 0
        End Select
    End If

End Function
Private Function WidthBytes(ByVal lWidth As Long) As Long

   WidthBytes = ((lWidth + 31) \ 32) * 4
   
End Function
